<?php

namespace Drupal\djovernetzung\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

class djoVernetzungConfigForm extends ConfigFormBase {

	/**
	 * {@inheritdoc}
	 */
	public function getFormId()
	{
		return 'djovernetzung_config_form';
	}

	/**
	 * {@inheritdoc}
	 */
	public function buildForm(array $form, FormStateInterface $form_state)
	{
		$form = parent::buildForm($form, $form_state);
		$config = $this->config('djovernetzung.settings');

		$form['anbieterkennung'] = array(
			'#type'				=> 'textfield',
			'#title'			=> $this->t('Anbieterkennung (optional)'),
			'#default_value'	=> $config->get('anbieterkennung'),
			'#description'		=> $this->t('Eine kurze Bezeichnung Ihres Dienstes. Standard: Website-Name'),
			'#size'				=> 40,
		);
		$form['email'] = array(
			'#type'				=> 'textfield',
			'#title'			=> $this->t('Kontakt-E-mail (optional)'),
			'#default_value'	=> '',
			'#description'		=> $this->t('Falls wir Sie bei Problemen kontaktieren m&uuml;ssen.'),
			'#size'				=> 40,
		);
		$form['linkformat'] = array(
			'#type'				=> 'select',
			'#title'			=> $this->t('Erweitertes Linkformat. (weit: "&sect; 113 BGB " / schmal: "113")'),
			'#options'			=> array(
				'weit'		=> $this->t('weit'),
				'schmal'	=> $this->t('schmal'),
			),
			'#default_value'	=> $config->get('linkformat'),
		);
		$form['class'] = array(
			'#type'				=> 'textfield',
			'#title'			=> $this->t('CSS Klasse (optional)'),
			'#default_value'	=> $config->get('class'),
			'#description'		=> $this->t('Wenn Sie den Links zu dejure.org eine bestimmte CSS-Klasse zuweisen wollen. Mehrere mit Leerzeichen trennen.'),
			'#size'				=> 40,
		);
		$form['target'] = array(
			'#type'				=> 'textfield',
			'#title'			=> $this->t('Ziel der Links (optional)'),
			'#default_value'	=> $config->get('target'),
			'#description'		=> $this->t('Zum Beispiel "_blank" f&uuml;r ein neues Fenster.'),
			'#size'				=> 40,
		);
		$form['buzer'] = array(
			'#type'				=> 'checkbox',
			'#title'			=> $this->t('Buzer Gesetze'),
			'#default_value'	=> $config->get('buzer'),
			'#description'		=> $this->t('Zu <a href="https://buzer.de">buzer.de</a> verlinken f&uuml;r Gesetze, die bei dejure.org nicht vorhanden sind.'),
		);

		return $form;
	}

	/**
	 * {@inheritdoc}
	 */
	public function validateForm(array &$form, FormStateInterface $form_state) {

	}

	/**
	 * {@inheritdoc}
	 */
	public function submitForm(array &$form, FormStateInterface $form_state)
	{
		$config = $this->config('djovernetzung.settings');

		$config->set('anbieterkennung', $form_state->getValue('anbieterkennung'));
		$config->set('email', $form_state->getValue('email'));
		$config->set('linkformat', $form_state->getValue('linkformat'));
		$config->set('class', $form_state->getValue('class'));
		$config->set('target', $form_state->getValue('target'));
		$config->set('buzer', $form_state->getValue('buzer'));
		$config->save();


		return parent::submitForm($form, $form_state);
	}

	/**
	 * {@inheritdoc}
	 */
	protected function getEditableConfigNames() {
		return [
			'djovernetzung.settings',
		];
	}

}
